// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package fakes

import (
	context "context"
	sync "sync"
	time "time"

	controller "github.com/rancher/norman/controller"
	objectclient "github.com/rancher/norman/objectclient"
	v3 "github.com/rancher/types/apis/management.cattle.io/v3"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

var (
	lockGlobalDNSProviderListerMockGet  sync.RWMutex
	lockGlobalDNSProviderListerMockList sync.RWMutex
)

// Ensure, that GlobalDNSProviderListerMock does implement GlobalDNSProviderLister.
// If this is not the case, regenerate this file with moq.
var _ v3.GlobalDNSProviderLister = &GlobalDNSProviderListerMock{}

// GlobalDNSProviderListerMock is a mock implementation of GlobalDNSProviderLister.
//
//     func TestSomethingThatUsesGlobalDNSProviderLister(t *testing.T) {
//
//         // make and configure a mocked GlobalDNSProviderLister
//         mockedGlobalDNSProviderLister := &GlobalDNSProviderListerMock{
//             GetFunc: func(namespace string, name string) (*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the Get method")
//             },
//             ListFunc: func(namespace string, selector labels.Selector) ([]*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the List method")
//             },
//         }
//
//         // use mockedGlobalDNSProviderLister in code that requires GlobalDNSProviderLister
//         // and then make assertions.
//
//     }
type GlobalDNSProviderListerMock struct {
	// GetFunc mocks the Get method.
	GetFunc func(namespace string, name string) (*v3.GlobalDNSProvider, error)

	// ListFunc mocks the List method.
	ListFunc func(namespace string, selector labels.Selector) ([]*v3.GlobalDNSProvider, error)

	// calls tracks calls to the methods.
	calls struct {
		// Get holds details about calls to the Get method.
		Get []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Selector is the selector argument value.
			Selector labels.Selector
		}
	}
}

// Get calls GetFunc.
func (mock *GlobalDNSProviderListerMock) Get(namespace string, name string) (*v3.GlobalDNSProvider, error) {
	if mock.GetFunc == nil {
		panic("GlobalDNSProviderListerMock.GetFunc: method is nil but GlobalDNSProviderLister.Get was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockGlobalDNSProviderListerMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockGlobalDNSProviderListerMockGet.Unlock()
	return mock.GetFunc(namespace, name)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedGlobalDNSProviderLister.GetCalls())
func (mock *GlobalDNSProviderListerMock) GetCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockGlobalDNSProviderListerMockGet.RLock()
	calls = mock.calls.Get
	lockGlobalDNSProviderListerMockGet.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *GlobalDNSProviderListerMock) List(namespace string, selector labels.Selector) ([]*v3.GlobalDNSProvider, error) {
	if mock.ListFunc == nil {
		panic("GlobalDNSProviderListerMock.ListFunc: method is nil but GlobalDNSProviderLister.List was just called")
	}
	callInfo := struct {
		Namespace string
		Selector  labels.Selector
	}{
		Namespace: namespace,
		Selector:  selector,
	}
	lockGlobalDNSProviderListerMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockGlobalDNSProviderListerMockList.Unlock()
	return mock.ListFunc(namespace, selector)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedGlobalDNSProviderLister.ListCalls())
func (mock *GlobalDNSProviderListerMock) ListCalls() []struct {
	Namespace string
	Selector  labels.Selector
} {
	var calls []struct {
		Namespace string
		Selector  labels.Selector
	}
	lockGlobalDNSProviderListerMockList.RLock()
	calls = mock.calls.List
	lockGlobalDNSProviderListerMockList.RUnlock()
	return calls
}

var (
	lockGlobalDNSProviderControllerMockAddClusterScopedFeatureHandler sync.RWMutex
	lockGlobalDNSProviderControllerMockAddClusterScopedHandler        sync.RWMutex
	lockGlobalDNSProviderControllerMockAddFeatureHandler              sync.RWMutex
	lockGlobalDNSProviderControllerMockAddHandler                     sync.RWMutex
	lockGlobalDNSProviderControllerMockEnqueue                        sync.RWMutex
	lockGlobalDNSProviderControllerMockEnqueueAfter                   sync.RWMutex
	lockGlobalDNSProviderControllerMockGeneric                        sync.RWMutex
	lockGlobalDNSProviderControllerMockInformer                       sync.RWMutex
	lockGlobalDNSProviderControllerMockLister                         sync.RWMutex
)

// Ensure, that GlobalDNSProviderControllerMock does implement GlobalDNSProviderController.
// If this is not the case, regenerate this file with moq.
var _ v3.GlobalDNSProviderController = &GlobalDNSProviderControllerMock{}

// GlobalDNSProviderControllerMock is a mock implementation of GlobalDNSProviderController.
//
//     func TestSomethingThatUsesGlobalDNSProviderController(t *testing.T) {
//
//         // make and configure a mocked GlobalDNSProviderController
//         mockedGlobalDNSProviderController := &GlobalDNSProviderControllerMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, handler v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             EnqueueFunc: func(namespace string, name string)  {
// 	               panic("mock out the Enqueue method")
//             },
//             EnqueueAfterFunc: func(namespace string, name string, after time.Duration)  {
// 	               panic("mock out the EnqueueAfter method")
//             },
//             GenericFunc: func() controller.GenericController {
// 	               panic("mock out the Generic method")
//             },
//             InformerFunc: func() cache.SharedIndexInformer {
// 	               panic("mock out the Informer method")
//             },
//             ListerFunc: func() v3.GlobalDNSProviderLister {
// 	               panic("mock out the Lister method")
//             },
//         }
//
//         // use mockedGlobalDNSProviderController in code that requires GlobalDNSProviderController
//         // and then make assertions.
//
//     }
type GlobalDNSProviderControllerMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, handler v3.GlobalDNSProviderHandlerFunc)

	// EnqueueFunc mocks the Enqueue method.
	EnqueueFunc func(namespace string, name string)

	// EnqueueAfterFunc mocks the EnqueueAfter method.
	EnqueueAfterFunc func(namespace string, name string, after time.Duration)

	// GenericFunc mocks the Generic method.
	GenericFunc func() controller.GenericController

	// InformerFunc mocks the Informer method.
	InformerFunc func() cache.SharedIndexInformer

	// ListerFunc mocks the Lister method.
	ListerFunc func() v3.GlobalDNSProviderLister

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.GlobalDNSProviderHandlerFunc
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Handler is the handler argument value.
			Handler v3.GlobalDNSProviderHandlerFunc
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.GlobalDNSProviderHandlerFunc
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Handler is the handler argument value.
			Handler v3.GlobalDNSProviderHandlerFunc
		}
		// Enqueue holds details about calls to the Enqueue method.
		Enqueue []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
		}
		// EnqueueAfter holds details about calls to the EnqueueAfter method.
		EnqueueAfter []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// After is the after argument value.
			After time.Duration
		}
		// Generic holds details about calls to the Generic method.
		Generic []struct {
		}
		// Informer holds details about calls to the Informer method.
		Informer []struct {
		}
		// Lister holds details about calls to the Lister method.
		Lister []struct {
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *GlobalDNSProviderControllerMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("GlobalDNSProviderControllerMock.AddClusterScopedFeatureHandlerFunc: method is nil but GlobalDNSProviderController.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockGlobalDNSProviderControllerMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockGlobalDNSProviderControllerMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, handler)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderController.AddClusterScopedFeatureHandlerCalls())
func (mock *GlobalDNSProviderControllerMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Handler     v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Handler     v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderControllerMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockGlobalDNSProviderControllerMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *GlobalDNSProviderControllerMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, handler v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("GlobalDNSProviderControllerMock.AddClusterScopedHandlerFunc: method is nil but GlobalDNSProviderController.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Handler:     handler,
	}
	lockGlobalDNSProviderControllerMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockGlobalDNSProviderControllerMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, handler)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderController.AddClusterScopedHandlerCalls())
func (mock *GlobalDNSProviderControllerMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Handler     v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Handler     v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderControllerMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockGlobalDNSProviderControllerMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *GlobalDNSProviderControllerMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("GlobalDNSProviderControllerMock.AddFeatureHandlerFunc: method is nil but GlobalDNSProviderController.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockGlobalDNSProviderControllerMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockGlobalDNSProviderControllerMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderController.AddFeatureHandlerCalls())
func (mock *GlobalDNSProviderControllerMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderControllerMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockGlobalDNSProviderControllerMockAddFeatureHandler.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *GlobalDNSProviderControllerMock) AddHandler(ctx context.Context, name string, handler v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("GlobalDNSProviderControllerMock.AddHandlerFunc: method is nil but GlobalDNSProviderController.AddHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Name    string
		Handler v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:     ctx,
		Name:    name,
		Handler: handler,
	}
	lockGlobalDNSProviderControllerMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockGlobalDNSProviderControllerMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, handler)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderController.AddHandlerCalls())
func (mock *GlobalDNSProviderControllerMock) AddHandlerCalls() []struct {
	Ctx     context.Context
	Name    string
	Handler v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Name    string
		Handler v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderControllerMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockGlobalDNSProviderControllerMockAddHandler.RUnlock()
	return calls
}

// Enqueue calls EnqueueFunc.
func (mock *GlobalDNSProviderControllerMock) Enqueue(namespace string, name string) {
	if mock.EnqueueFunc == nil {
		panic("GlobalDNSProviderControllerMock.EnqueueFunc: method is nil but GlobalDNSProviderController.Enqueue was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
	}{
		Namespace: namespace,
		Name:      name,
	}
	lockGlobalDNSProviderControllerMockEnqueue.Lock()
	mock.calls.Enqueue = append(mock.calls.Enqueue, callInfo)
	lockGlobalDNSProviderControllerMockEnqueue.Unlock()
	mock.EnqueueFunc(namespace, name)
}

// EnqueueCalls gets all the calls that were made to Enqueue.
// Check the length with:
//     len(mockedGlobalDNSProviderController.EnqueueCalls())
func (mock *GlobalDNSProviderControllerMock) EnqueueCalls() []struct {
	Namespace string
	Name      string
} {
	var calls []struct {
		Namespace string
		Name      string
	}
	lockGlobalDNSProviderControllerMockEnqueue.RLock()
	calls = mock.calls.Enqueue
	lockGlobalDNSProviderControllerMockEnqueue.RUnlock()
	return calls
}

// EnqueueAfter calls EnqueueAfterFunc.
func (mock *GlobalDNSProviderControllerMock) EnqueueAfter(namespace string, name string, after time.Duration) {
	if mock.EnqueueAfterFunc == nil {
		panic("GlobalDNSProviderControllerMock.EnqueueAfterFunc: method is nil but GlobalDNSProviderController.EnqueueAfter was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		After     time.Duration
	}{
		Namespace: namespace,
		Name:      name,
		After:     after,
	}
	lockGlobalDNSProviderControllerMockEnqueueAfter.Lock()
	mock.calls.EnqueueAfter = append(mock.calls.EnqueueAfter, callInfo)
	lockGlobalDNSProviderControllerMockEnqueueAfter.Unlock()
	mock.EnqueueAfterFunc(namespace, name, after)
}

// EnqueueAfterCalls gets all the calls that were made to EnqueueAfter.
// Check the length with:
//     len(mockedGlobalDNSProviderController.EnqueueAfterCalls())
func (mock *GlobalDNSProviderControllerMock) EnqueueAfterCalls() []struct {
	Namespace string
	Name      string
	After     time.Duration
} {
	var calls []struct {
		Namespace string
		Name      string
		After     time.Duration
	}
	lockGlobalDNSProviderControllerMockEnqueueAfter.RLock()
	calls = mock.calls.EnqueueAfter
	lockGlobalDNSProviderControllerMockEnqueueAfter.RUnlock()
	return calls
}

// Generic calls GenericFunc.
func (mock *GlobalDNSProviderControllerMock) Generic() controller.GenericController {
	if mock.GenericFunc == nil {
		panic("GlobalDNSProviderControllerMock.GenericFunc: method is nil but GlobalDNSProviderController.Generic was just called")
	}
	callInfo := struct {
	}{}
	lockGlobalDNSProviderControllerMockGeneric.Lock()
	mock.calls.Generic = append(mock.calls.Generic, callInfo)
	lockGlobalDNSProviderControllerMockGeneric.Unlock()
	return mock.GenericFunc()
}

// GenericCalls gets all the calls that were made to Generic.
// Check the length with:
//     len(mockedGlobalDNSProviderController.GenericCalls())
func (mock *GlobalDNSProviderControllerMock) GenericCalls() []struct {
} {
	var calls []struct {
	}
	lockGlobalDNSProviderControllerMockGeneric.RLock()
	calls = mock.calls.Generic
	lockGlobalDNSProviderControllerMockGeneric.RUnlock()
	return calls
}

// Informer calls InformerFunc.
func (mock *GlobalDNSProviderControllerMock) Informer() cache.SharedIndexInformer {
	if mock.InformerFunc == nil {
		panic("GlobalDNSProviderControllerMock.InformerFunc: method is nil but GlobalDNSProviderController.Informer was just called")
	}
	callInfo := struct {
	}{}
	lockGlobalDNSProviderControllerMockInformer.Lock()
	mock.calls.Informer = append(mock.calls.Informer, callInfo)
	lockGlobalDNSProviderControllerMockInformer.Unlock()
	return mock.InformerFunc()
}

// InformerCalls gets all the calls that were made to Informer.
// Check the length with:
//     len(mockedGlobalDNSProviderController.InformerCalls())
func (mock *GlobalDNSProviderControllerMock) InformerCalls() []struct {
} {
	var calls []struct {
	}
	lockGlobalDNSProviderControllerMockInformer.RLock()
	calls = mock.calls.Informer
	lockGlobalDNSProviderControllerMockInformer.RUnlock()
	return calls
}

// Lister calls ListerFunc.
func (mock *GlobalDNSProviderControllerMock) Lister() v3.GlobalDNSProviderLister {
	if mock.ListerFunc == nil {
		panic("GlobalDNSProviderControllerMock.ListerFunc: method is nil but GlobalDNSProviderController.Lister was just called")
	}
	callInfo := struct {
	}{}
	lockGlobalDNSProviderControllerMockLister.Lock()
	mock.calls.Lister = append(mock.calls.Lister, callInfo)
	lockGlobalDNSProviderControllerMockLister.Unlock()
	return mock.ListerFunc()
}

// ListerCalls gets all the calls that were made to Lister.
// Check the length with:
//     len(mockedGlobalDNSProviderController.ListerCalls())
func (mock *GlobalDNSProviderControllerMock) ListerCalls() []struct {
} {
	var calls []struct {
	}
	lockGlobalDNSProviderControllerMockLister.RLock()
	calls = mock.calls.Lister
	lockGlobalDNSProviderControllerMockLister.RUnlock()
	return calls
}

var (
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureHandler   sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureLifecycle sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddClusterScopedHandler          sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddClusterScopedLifecycle        sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddFeatureHandler                sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddFeatureLifecycle              sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddHandler                       sync.RWMutex
	lockGlobalDNSProviderInterfaceMockAddLifecycle                     sync.RWMutex
	lockGlobalDNSProviderInterfaceMockController                       sync.RWMutex
	lockGlobalDNSProviderInterfaceMockCreate                           sync.RWMutex
	lockGlobalDNSProviderInterfaceMockDelete                           sync.RWMutex
	lockGlobalDNSProviderInterfaceMockDeleteCollection                 sync.RWMutex
	lockGlobalDNSProviderInterfaceMockDeleteNamespaced                 sync.RWMutex
	lockGlobalDNSProviderInterfaceMockGet                              sync.RWMutex
	lockGlobalDNSProviderInterfaceMockGetNamespaced                    sync.RWMutex
	lockGlobalDNSProviderInterfaceMockList                             sync.RWMutex
	lockGlobalDNSProviderInterfaceMockListNamespaced                   sync.RWMutex
	lockGlobalDNSProviderInterfaceMockObjectClient                     sync.RWMutex
	lockGlobalDNSProviderInterfaceMockUpdate                           sync.RWMutex
	lockGlobalDNSProviderInterfaceMockWatch                            sync.RWMutex
)

// Ensure, that GlobalDNSProviderInterfaceMock does implement GlobalDNSProviderInterface.
// If this is not the case, regenerate this file with moq.
var _ v3.GlobalDNSProviderInterface = &GlobalDNSProviderInterfaceMock{}

// GlobalDNSProviderInterfaceMock is a mock implementation of GlobalDNSProviderInterface.
//
//     func TestSomethingThatUsesGlobalDNSProviderInterface(t *testing.T) {
//
//         // make and configure a mocked GlobalDNSProviderInterface
//         mockedGlobalDNSProviderInterface := &GlobalDNSProviderInterfaceMock{
//             AddClusterScopedFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedFeatureHandler method")
//             },
//             AddClusterScopedFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle)  {
// 	               panic("mock out the AddClusterScopedFeatureLifecycle method")
//             },
//             AddClusterScopedHandlerFunc: func(ctx context.Context, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddClusterScopedHandler method")
//             },
//             AddClusterScopedLifecycleFunc: func(ctx context.Context, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle)  {
// 	               panic("mock out the AddClusterScopedLifecycle method")
//             },
//             AddFeatureHandlerFunc: func(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddFeatureHandler method")
//             },
//             AddFeatureLifecycleFunc: func(ctx context.Context, enabled func() bool, name string, lifecycle v3.GlobalDNSProviderLifecycle)  {
// 	               panic("mock out the AddFeatureLifecycle method")
//             },
//             AddHandlerFunc: func(ctx context.Context, name string, sync v3.GlobalDNSProviderHandlerFunc)  {
// 	               panic("mock out the AddHandler method")
//             },
//             AddLifecycleFunc: func(ctx context.Context, name string, lifecycle v3.GlobalDNSProviderLifecycle)  {
// 	               panic("mock out the AddLifecycle method")
//             },
//             ControllerFunc: func() v3.GlobalDNSProviderController {
// 	               panic("mock out the Controller method")
//             },
//             CreateFunc: func(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the Delete method")
//             },
//             DeleteCollectionFunc: func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
// 	               panic("mock out the DeleteCollection method")
//             },
//             DeleteNamespacedFunc: func(namespace string, name string, options *v1.DeleteOptions) error {
// 	               panic("mock out the DeleteNamespaced method")
//             },
//             GetFunc: func(name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the Get method")
//             },
//             GetNamespacedFunc: func(namespace string, name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the GetNamespaced method")
//             },
//             ListFunc: func(opts v1.ListOptions) (*v3.GlobalDNSProviderList, error) {
// 	               panic("mock out the List method")
//             },
//             ListNamespacedFunc: func(namespace string, opts v1.ListOptions) (*v3.GlobalDNSProviderList, error) {
// 	               panic("mock out the ListNamespaced method")
//             },
//             ObjectClientFunc: func() *objectclient.ObjectClient {
// 	               panic("mock out the ObjectClient method")
//             },
//             UpdateFunc: func(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error) {
// 	               panic("mock out the Update method")
//             },
//             WatchFunc: func(opts v1.ListOptions) (watch.Interface, error) {
// 	               panic("mock out the Watch method")
//             },
//         }
//
//         // use mockedGlobalDNSProviderInterface in code that requires GlobalDNSProviderInterface
//         // and then make assertions.
//
//     }
type GlobalDNSProviderInterfaceMock struct {
	// AddClusterScopedFeatureHandlerFunc mocks the AddClusterScopedFeatureHandler method.
	AddClusterScopedFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc)

	// AddClusterScopedFeatureLifecycleFunc mocks the AddClusterScopedFeatureLifecycle method.
	AddClusterScopedFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle)

	// AddClusterScopedHandlerFunc mocks the AddClusterScopedHandler method.
	AddClusterScopedHandlerFunc func(ctx context.Context, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc)

	// AddClusterScopedLifecycleFunc mocks the AddClusterScopedLifecycle method.
	AddClusterScopedLifecycleFunc func(ctx context.Context, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle)

	// AddFeatureHandlerFunc mocks the AddFeatureHandler method.
	AddFeatureHandlerFunc func(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc)

	// AddFeatureLifecycleFunc mocks the AddFeatureLifecycle method.
	AddFeatureLifecycleFunc func(ctx context.Context, enabled func() bool, name string, lifecycle v3.GlobalDNSProviderLifecycle)

	// AddHandlerFunc mocks the AddHandler method.
	AddHandlerFunc func(ctx context.Context, name string, sync v3.GlobalDNSProviderHandlerFunc)

	// AddLifecycleFunc mocks the AddLifecycle method.
	AddLifecycleFunc func(ctx context.Context, name string, lifecycle v3.GlobalDNSProviderLifecycle)

	// ControllerFunc mocks the Controller method.
	ControllerFunc func() v3.GlobalDNSProviderController

	// CreateFunc mocks the Create method.
	CreateFunc func(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(name string, options *v1.DeleteOptions) error

	// DeleteCollectionFunc mocks the DeleteCollection method.
	DeleteCollectionFunc func(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error

	// DeleteNamespacedFunc mocks the DeleteNamespaced method.
	DeleteNamespacedFunc func(namespace string, name string, options *v1.DeleteOptions) error

	// GetFunc mocks the Get method.
	GetFunc func(name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error)

	// GetNamespacedFunc mocks the GetNamespaced method.
	GetNamespacedFunc func(namespace string, name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error)

	// ListFunc mocks the List method.
	ListFunc func(opts v1.ListOptions) (*v3.GlobalDNSProviderList, error)

	// ListNamespacedFunc mocks the ListNamespaced method.
	ListNamespacedFunc func(namespace string, opts v1.ListOptions) (*v3.GlobalDNSProviderList, error)

	// ObjectClientFunc mocks the ObjectClient method.
	ObjectClientFunc func() *objectclient.ObjectClient

	// UpdateFunc mocks the Update method.
	UpdateFunc func(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error)

	// WatchFunc mocks the Watch method.
	WatchFunc func(opts v1.ListOptions) (watch.Interface, error)

	// calls tracks calls to the methods.
	calls struct {
		// AddClusterScopedFeatureHandler holds details about calls to the AddClusterScopedFeatureHandler method.
		AddClusterScopedFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.GlobalDNSProviderHandlerFunc
		}
		// AddClusterScopedFeatureLifecycle holds details about calls to the AddClusterScopedFeatureLifecycle method.
		AddClusterScopedFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.GlobalDNSProviderLifecycle
		}
		// AddClusterScopedHandler holds details about calls to the AddClusterScopedHandler method.
		AddClusterScopedHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Sync is the sync argument value.
			Sync v3.GlobalDNSProviderHandlerFunc
		}
		// AddClusterScopedLifecycle holds details about calls to the AddClusterScopedLifecycle method.
		AddClusterScopedLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// ClusterName is the clusterName argument value.
			ClusterName string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.GlobalDNSProviderLifecycle
		}
		// AddFeatureHandler holds details about calls to the AddFeatureHandler method.
		AddFeatureHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.GlobalDNSProviderHandlerFunc
		}
		// AddFeatureLifecycle holds details about calls to the AddFeatureLifecycle method.
		AddFeatureLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Enabled is the enabled argument value.
			Enabled func() bool
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.GlobalDNSProviderLifecycle
		}
		// AddHandler holds details about calls to the AddHandler method.
		AddHandler []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Sync is the sync argument value.
			Sync v3.GlobalDNSProviderHandlerFunc
		}
		// AddLifecycle holds details about calls to the AddLifecycle method.
		AddLifecycle []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Name is the name argument value.
			Name string
			// Lifecycle is the lifecycle argument value.
			Lifecycle v3.GlobalDNSProviderLifecycle
		}
		// Controller holds details about calls to the Controller method.
		Controller []struct {
		}
		// Create holds details about calls to the Create method.
		Create []struct {
			// In1 is the in1 argument value.
			In1 *v3.GlobalDNSProvider
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// DeleteCollection holds details about calls to the DeleteCollection method.
		DeleteCollection []struct {
			// DeleteOpts is the deleteOpts argument value.
			DeleteOpts *v1.DeleteOptions
			// ListOpts is the listOpts argument value.
			ListOpts v1.ListOptions
		}
		// DeleteNamespaced holds details about calls to the DeleteNamespaced method.
		DeleteNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Options is the options argument value.
			Options *v1.DeleteOptions
		}
		// Get holds details about calls to the Get method.
		Get []struct {
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// GetNamespaced holds details about calls to the GetNamespaced method.
		GetNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Name is the name argument value.
			Name string
			// Opts is the opts argument value.
			Opts v1.GetOptions
		}
		// List holds details about calls to the List method.
		List []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ListNamespaced holds details about calls to the ListNamespaced method.
		ListNamespaced []struct {
			// Namespace is the namespace argument value.
			Namespace string
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
		// ObjectClient holds details about calls to the ObjectClient method.
		ObjectClient []struct {
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// In1 is the in1 argument value.
			In1 *v3.GlobalDNSProvider
		}
		// Watch holds details about calls to the Watch method.
		Watch []struct {
			// Opts is the opts argument value.
			Opts v1.ListOptions
		}
	}
}

// AddClusterScopedFeatureHandler calls AddClusterScopedFeatureHandlerFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedFeatureHandler(ctx context.Context, enabled func() bool, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddClusterScopedFeatureHandlerFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddClusterScopedFeatureHandlerFunc: method is nil but GlobalDNSProviderInterface.AddClusterScopedFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureHandler.Lock()
	mock.calls.AddClusterScopedFeatureHandler = append(mock.calls.AddClusterScopedFeatureHandler, callInfo)
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureHandler.Unlock()
	mock.AddClusterScopedFeatureHandlerFunc(ctx, enabled, name, clusterName, sync)
}

// AddClusterScopedFeatureHandlerCalls gets all the calls that were made to AddClusterScopedFeatureHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddClusterScopedFeatureHandlerCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedFeatureHandlerCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Sync        v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Sync        v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureHandler.RLock()
	calls = mock.calls.AddClusterScopedFeatureHandler
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureHandler.RUnlock()
	return calls
}

// AddClusterScopedFeatureLifecycle calls AddClusterScopedFeatureLifecycleFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedFeatureLifecycle(ctx context.Context, enabled func() bool, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle) {
	if mock.AddClusterScopedFeatureLifecycleFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddClusterScopedFeatureLifecycleFunc: method is nil but GlobalDNSProviderInterface.AddClusterScopedFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.GlobalDNSProviderLifecycle
	}{
		Ctx:         ctx,
		Enabled:     enabled,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureLifecycle.Lock()
	mock.calls.AddClusterScopedFeatureLifecycle = append(mock.calls.AddClusterScopedFeatureLifecycle, callInfo)
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureLifecycle.Unlock()
	mock.AddClusterScopedFeatureLifecycleFunc(ctx, enabled, name, clusterName, lifecycle)
}

// AddClusterScopedFeatureLifecycleCalls gets all the calls that were made to AddClusterScopedFeatureLifecycle.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddClusterScopedFeatureLifecycleCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedFeatureLifecycleCalls() []struct {
	Ctx         context.Context
	Enabled     func() bool
	Name        string
	ClusterName string
	Lifecycle   v3.GlobalDNSProviderLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Enabled     func() bool
		Name        string
		ClusterName string
		Lifecycle   v3.GlobalDNSProviderLifecycle
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureLifecycle.RLock()
	calls = mock.calls.AddClusterScopedFeatureLifecycle
	lockGlobalDNSProviderInterfaceMockAddClusterScopedFeatureLifecycle.RUnlock()
	return calls
}

// AddClusterScopedHandler calls AddClusterScopedHandlerFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedHandler(ctx context.Context, name string, clusterName string, sync v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddClusterScopedHandlerFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddClusterScopedHandlerFunc: method is nil but GlobalDNSProviderInterface.AddClusterScopedHandler was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Sync:        sync,
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedHandler.Lock()
	mock.calls.AddClusterScopedHandler = append(mock.calls.AddClusterScopedHandler, callInfo)
	lockGlobalDNSProviderInterfaceMockAddClusterScopedHandler.Unlock()
	mock.AddClusterScopedHandlerFunc(ctx, name, clusterName, sync)
}

// AddClusterScopedHandlerCalls gets all the calls that were made to AddClusterScopedHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddClusterScopedHandlerCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedHandlerCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Sync        v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Sync        v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedHandler.RLock()
	calls = mock.calls.AddClusterScopedHandler
	lockGlobalDNSProviderInterfaceMockAddClusterScopedHandler.RUnlock()
	return calls
}

// AddClusterScopedLifecycle calls AddClusterScopedLifecycleFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedLifecycle(ctx context.Context, name string, clusterName string, lifecycle v3.GlobalDNSProviderLifecycle) {
	if mock.AddClusterScopedLifecycleFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddClusterScopedLifecycleFunc: method is nil but GlobalDNSProviderInterface.AddClusterScopedLifecycle was just called")
	}
	callInfo := struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.GlobalDNSProviderLifecycle
	}{
		Ctx:         ctx,
		Name:        name,
		ClusterName: clusterName,
		Lifecycle:   lifecycle,
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedLifecycle.Lock()
	mock.calls.AddClusterScopedLifecycle = append(mock.calls.AddClusterScopedLifecycle, callInfo)
	lockGlobalDNSProviderInterfaceMockAddClusterScopedLifecycle.Unlock()
	mock.AddClusterScopedLifecycleFunc(ctx, name, clusterName, lifecycle)
}

// AddClusterScopedLifecycleCalls gets all the calls that were made to AddClusterScopedLifecycle.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddClusterScopedLifecycleCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddClusterScopedLifecycleCalls() []struct {
	Ctx         context.Context
	Name        string
	ClusterName string
	Lifecycle   v3.GlobalDNSProviderLifecycle
} {
	var calls []struct {
		Ctx         context.Context
		Name        string
		ClusterName string
		Lifecycle   v3.GlobalDNSProviderLifecycle
	}
	lockGlobalDNSProviderInterfaceMockAddClusterScopedLifecycle.RLock()
	calls = mock.calls.AddClusterScopedLifecycle
	lockGlobalDNSProviderInterfaceMockAddClusterScopedLifecycle.RUnlock()
	return calls
}

// AddFeatureHandler calls AddFeatureHandlerFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddFeatureHandler(ctx context.Context, enabled func() bool, name string, sync v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddFeatureHandlerFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddFeatureHandlerFunc: method is nil but GlobalDNSProviderInterface.AddFeatureHandler was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:     ctx,
		Enabled: enabled,
		Name:    name,
		Sync:    sync,
	}
	lockGlobalDNSProviderInterfaceMockAddFeatureHandler.Lock()
	mock.calls.AddFeatureHandler = append(mock.calls.AddFeatureHandler, callInfo)
	lockGlobalDNSProviderInterfaceMockAddFeatureHandler.Unlock()
	mock.AddFeatureHandlerFunc(ctx, enabled, name, sync)
}

// AddFeatureHandlerCalls gets all the calls that were made to AddFeatureHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddFeatureHandlerCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddFeatureHandlerCalls() []struct {
	Ctx     context.Context
	Enabled func() bool
	Name    string
	Sync    v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx     context.Context
		Enabled func() bool
		Name    string
		Sync    v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderInterfaceMockAddFeatureHandler.RLock()
	calls = mock.calls.AddFeatureHandler
	lockGlobalDNSProviderInterfaceMockAddFeatureHandler.RUnlock()
	return calls
}

// AddFeatureLifecycle calls AddFeatureLifecycleFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddFeatureLifecycle(ctx context.Context, enabled func() bool, name string, lifecycle v3.GlobalDNSProviderLifecycle) {
	if mock.AddFeatureLifecycleFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddFeatureLifecycleFunc: method is nil but GlobalDNSProviderInterface.AddFeatureLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.GlobalDNSProviderLifecycle
	}{
		Ctx:       ctx,
		Enabled:   enabled,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockGlobalDNSProviderInterfaceMockAddFeatureLifecycle.Lock()
	mock.calls.AddFeatureLifecycle = append(mock.calls.AddFeatureLifecycle, callInfo)
	lockGlobalDNSProviderInterfaceMockAddFeatureLifecycle.Unlock()
	mock.AddFeatureLifecycleFunc(ctx, enabled, name, lifecycle)
}

// AddFeatureLifecycleCalls gets all the calls that were made to AddFeatureLifecycle.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddFeatureLifecycleCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddFeatureLifecycleCalls() []struct {
	Ctx       context.Context
	Enabled   func() bool
	Name      string
	Lifecycle v3.GlobalDNSProviderLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Enabled   func() bool
		Name      string
		Lifecycle v3.GlobalDNSProviderLifecycle
	}
	lockGlobalDNSProviderInterfaceMockAddFeatureLifecycle.RLock()
	calls = mock.calls.AddFeatureLifecycle
	lockGlobalDNSProviderInterfaceMockAddFeatureLifecycle.RUnlock()
	return calls
}

// AddHandler calls AddHandlerFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddHandler(ctx context.Context, name string, sync v3.GlobalDNSProviderHandlerFunc) {
	if mock.AddHandlerFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddHandlerFunc: method is nil but GlobalDNSProviderInterface.AddHandler was just called")
	}
	callInfo := struct {
		Ctx  context.Context
		Name string
		Sync v3.GlobalDNSProviderHandlerFunc
	}{
		Ctx:  ctx,
		Name: name,
		Sync: sync,
	}
	lockGlobalDNSProviderInterfaceMockAddHandler.Lock()
	mock.calls.AddHandler = append(mock.calls.AddHandler, callInfo)
	lockGlobalDNSProviderInterfaceMockAddHandler.Unlock()
	mock.AddHandlerFunc(ctx, name, sync)
}

// AddHandlerCalls gets all the calls that were made to AddHandler.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddHandlerCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddHandlerCalls() []struct {
	Ctx  context.Context
	Name string
	Sync v3.GlobalDNSProviderHandlerFunc
} {
	var calls []struct {
		Ctx  context.Context
		Name string
		Sync v3.GlobalDNSProviderHandlerFunc
	}
	lockGlobalDNSProviderInterfaceMockAddHandler.RLock()
	calls = mock.calls.AddHandler
	lockGlobalDNSProviderInterfaceMockAddHandler.RUnlock()
	return calls
}

// AddLifecycle calls AddLifecycleFunc.
func (mock *GlobalDNSProviderInterfaceMock) AddLifecycle(ctx context.Context, name string, lifecycle v3.GlobalDNSProviderLifecycle) {
	if mock.AddLifecycleFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.AddLifecycleFunc: method is nil but GlobalDNSProviderInterface.AddLifecycle was just called")
	}
	callInfo := struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.GlobalDNSProviderLifecycle
	}{
		Ctx:       ctx,
		Name:      name,
		Lifecycle: lifecycle,
	}
	lockGlobalDNSProviderInterfaceMockAddLifecycle.Lock()
	mock.calls.AddLifecycle = append(mock.calls.AddLifecycle, callInfo)
	lockGlobalDNSProviderInterfaceMockAddLifecycle.Unlock()
	mock.AddLifecycleFunc(ctx, name, lifecycle)
}

// AddLifecycleCalls gets all the calls that were made to AddLifecycle.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.AddLifecycleCalls())
func (mock *GlobalDNSProviderInterfaceMock) AddLifecycleCalls() []struct {
	Ctx       context.Context
	Name      string
	Lifecycle v3.GlobalDNSProviderLifecycle
} {
	var calls []struct {
		Ctx       context.Context
		Name      string
		Lifecycle v3.GlobalDNSProviderLifecycle
	}
	lockGlobalDNSProviderInterfaceMockAddLifecycle.RLock()
	calls = mock.calls.AddLifecycle
	lockGlobalDNSProviderInterfaceMockAddLifecycle.RUnlock()
	return calls
}

// Controller calls ControllerFunc.
func (mock *GlobalDNSProviderInterfaceMock) Controller() v3.GlobalDNSProviderController {
	if mock.ControllerFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.ControllerFunc: method is nil but GlobalDNSProviderInterface.Controller was just called")
	}
	callInfo := struct {
	}{}
	lockGlobalDNSProviderInterfaceMockController.Lock()
	mock.calls.Controller = append(mock.calls.Controller, callInfo)
	lockGlobalDNSProviderInterfaceMockController.Unlock()
	return mock.ControllerFunc()
}

// ControllerCalls gets all the calls that were made to Controller.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.ControllerCalls())
func (mock *GlobalDNSProviderInterfaceMock) ControllerCalls() []struct {
} {
	var calls []struct {
	}
	lockGlobalDNSProviderInterfaceMockController.RLock()
	calls = mock.calls.Controller
	lockGlobalDNSProviderInterfaceMockController.RUnlock()
	return calls
}

// Create calls CreateFunc.
func (mock *GlobalDNSProviderInterfaceMock) Create(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error) {
	if mock.CreateFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.CreateFunc: method is nil but GlobalDNSProviderInterface.Create was just called")
	}
	callInfo := struct {
		In1 *v3.GlobalDNSProvider
	}{
		In1: in1,
	}
	lockGlobalDNSProviderInterfaceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockGlobalDNSProviderInterfaceMockCreate.Unlock()
	return mock.CreateFunc(in1)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.CreateCalls())
func (mock *GlobalDNSProviderInterfaceMock) CreateCalls() []struct {
	In1 *v3.GlobalDNSProvider
} {
	var calls []struct {
		In1 *v3.GlobalDNSProvider
	}
	lockGlobalDNSProviderInterfaceMockCreate.RLock()
	calls = mock.calls.Create
	lockGlobalDNSProviderInterfaceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *GlobalDNSProviderInterfaceMock) Delete(name string, options *v1.DeleteOptions) error {
	if mock.DeleteFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.DeleteFunc: method is nil but GlobalDNSProviderInterface.Delete was just called")
	}
	callInfo := struct {
		Name    string
		Options *v1.DeleteOptions
	}{
		Name:    name,
		Options: options,
	}
	lockGlobalDNSProviderInterfaceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockGlobalDNSProviderInterfaceMockDelete.Unlock()
	return mock.DeleteFunc(name, options)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.DeleteCalls())
func (mock *GlobalDNSProviderInterfaceMock) DeleteCalls() []struct {
	Name    string
	Options *v1.DeleteOptions
} {
	var calls []struct {
		Name    string
		Options *v1.DeleteOptions
	}
	lockGlobalDNSProviderInterfaceMockDelete.RLock()
	calls = mock.calls.Delete
	lockGlobalDNSProviderInterfaceMockDelete.RUnlock()
	return calls
}

// DeleteCollection calls DeleteCollectionFunc.
func (mock *GlobalDNSProviderInterfaceMock) DeleteCollection(deleteOpts *v1.DeleteOptions, listOpts v1.ListOptions) error {
	if mock.DeleteCollectionFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.DeleteCollectionFunc: method is nil but GlobalDNSProviderInterface.DeleteCollection was just called")
	}
	callInfo := struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}{
		DeleteOpts: deleteOpts,
		ListOpts:   listOpts,
	}
	lockGlobalDNSProviderInterfaceMockDeleteCollection.Lock()
	mock.calls.DeleteCollection = append(mock.calls.DeleteCollection, callInfo)
	lockGlobalDNSProviderInterfaceMockDeleteCollection.Unlock()
	return mock.DeleteCollectionFunc(deleteOpts, listOpts)
}

// DeleteCollectionCalls gets all the calls that were made to DeleteCollection.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.DeleteCollectionCalls())
func (mock *GlobalDNSProviderInterfaceMock) DeleteCollectionCalls() []struct {
	DeleteOpts *v1.DeleteOptions
	ListOpts   v1.ListOptions
} {
	var calls []struct {
		DeleteOpts *v1.DeleteOptions
		ListOpts   v1.ListOptions
	}
	lockGlobalDNSProviderInterfaceMockDeleteCollection.RLock()
	calls = mock.calls.DeleteCollection
	lockGlobalDNSProviderInterfaceMockDeleteCollection.RUnlock()
	return calls
}

// DeleteNamespaced calls DeleteNamespacedFunc.
func (mock *GlobalDNSProviderInterfaceMock) DeleteNamespaced(namespace string, name string, options *v1.DeleteOptions) error {
	if mock.DeleteNamespacedFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.DeleteNamespacedFunc: method is nil but GlobalDNSProviderInterface.DeleteNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}{
		Namespace: namespace,
		Name:      name,
		Options:   options,
	}
	lockGlobalDNSProviderInterfaceMockDeleteNamespaced.Lock()
	mock.calls.DeleteNamespaced = append(mock.calls.DeleteNamespaced, callInfo)
	lockGlobalDNSProviderInterfaceMockDeleteNamespaced.Unlock()
	return mock.DeleteNamespacedFunc(namespace, name, options)
}

// DeleteNamespacedCalls gets all the calls that were made to DeleteNamespaced.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.DeleteNamespacedCalls())
func (mock *GlobalDNSProviderInterfaceMock) DeleteNamespacedCalls() []struct {
	Namespace string
	Name      string
	Options   *v1.DeleteOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Options   *v1.DeleteOptions
	}
	lockGlobalDNSProviderInterfaceMockDeleteNamespaced.RLock()
	calls = mock.calls.DeleteNamespaced
	lockGlobalDNSProviderInterfaceMockDeleteNamespaced.RUnlock()
	return calls
}

// Get calls GetFunc.
func (mock *GlobalDNSProviderInterfaceMock) Get(name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error) {
	if mock.GetFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.GetFunc: method is nil but GlobalDNSProviderInterface.Get was just called")
	}
	callInfo := struct {
		Name string
		Opts v1.GetOptions
	}{
		Name: name,
		Opts: opts,
	}
	lockGlobalDNSProviderInterfaceMockGet.Lock()
	mock.calls.Get = append(mock.calls.Get, callInfo)
	lockGlobalDNSProviderInterfaceMockGet.Unlock()
	return mock.GetFunc(name, opts)
}

// GetCalls gets all the calls that were made to Get.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.GetCalls())
func (mock *GlobalDNSProviderInterfaceMock) GetCalls() []struct {
	Name string
	Opts v1.GetOptions
} {
	var calls []struct {
		Name string
		Opts v1.GetOptions
	}
	lockGlobalDNSProviderInterfaceMockGet.RLock()
	calls = mock.calls.Get
	lockGlobalDNSProviderInterfaceMockGet.RUnlock()
	return calls
}

// GetNamespaced calls GetNamespacedFunc.
func (mock *GlobalDNSProviderInterfaceMock) GetNamespaced(namespace string, name string, opts v1.GetOptions) (*v3.GlobalDNSProvider, error) {
	if mock.GetNamespacedFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.GetNamespacedFunc: method is nil but GlobalDNSProviderInterface.GetNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}{
		Namespace: namespace,
		Name:      name,
		Opts:      opts,
	}
	lockGlobalDNSProviderInterfaceMockGetNamespaced.Lock()
	mock.calls.GetNamespaced = append(mock.calls.GetNamespaced, callInfo)
	lockGlobalDNSProviderInterfaceMockGetNamespaced.Unlock()
	return mock.GetNamespacedFunc(namespace, name, opts)
}

// GetNamespacedCalls gets all the calls that were made to GetNamespaced.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.GetNamespacedCalls())
func (mock *GlobalDNSProviderInterfaceMock) GetNamespacedCalls() []struct {
	Namespace string
	Name      string
	Opts      v1.GetOptions
} {
	var calls []struct {
		Namespace string
		Name      string
		Opts      v1.GetOptions
	}
	lockGlobalDNSProviderInterfaceMockGetNamespaced.RLock()
	calls = mock.calls.GetNamespaced
	lockGlobalDNSProviderInterfaceMockGetNamespaced.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *GlobalDNSProviderInterfaceMock) List(opts v1.ListOptions) (*v3.GlobalDNSProviderList, error) {
	if mock.ListFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.ListFunc: method is nil but GlobalDNSProviderInterface.List was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockGlobalDNSProviderInterfaceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockGlobalDNSProviderInterfaceMockList.Unlock()
	return mock.ListFunc(opts)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.ListCalls())
func (mock *GlobalDNSProviderInterfaceMock) ListCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockGlobalDNSProviderInterfaceMockList.RLock()
	calls = mock.calls.List
	lockGlobalDNSProviderInterfaceMockList.RUnlock()
	return calls
}

// ListNamespaced calls ListNamespacedFunc.
func (mock *GlobalDNSProviderInterfaceMock) ListNamespaced(namespace string, opts v1.ListOptions) (*v3.GlobalDNSProviderList, error) {
	if mock.ListNamespacedFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.ListNamespacedFunc: method is nil but GlobalDNSProviderInterface.ListNamespaced was just called")
	}
	callInfo := struct {
		Namespace string
		Opts      v1.ListOptions
	}{
		Namespace: namespace,
		Opts:      opts,
	}
	lockGlobalDNSProviderInterfaceMockListNamespaced.Lock()
	mock.calls.ListNamespaced = append(mock.calls.ListNamespaced, callInfo)
	lockGlobalDNSProviderInterfaceMockListNamespaced.Unlock()
	return mock.ListNamespacedFunc(namespace, opts)
}

// ListNamespacedCalls gets all the calls that were made to ListNamespaced.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.ListNamespacedCalls())
func (mock *GlobalDNSProviderInterfaceMock) ListNamespacedCalls() []struct {
	Namespace string
	Opts      v1.ListOptions
} {
	var calls []struct {
		Namespace string
		Opts      v1.ListOptions
	}
	lockGlobalDNSProviderInterfaceMockListNamespaced.RLock()
	calls = mock.calls.ListNamespaced
	lockGlobalDNSProviderInterfaceMockListNamespaced.RUnlock()
	return calls
}

// ObjectClient calls ObjectClientFunc.
func (mock *GlobalDNSProviderInterfaceMock) ObjectClient() *objectclient.ObjectClient {
	if mock.ObjectClientFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.ObjectClientFunc: method is nil but GlobalDNSProviderInterface.ObjectClient was just called")
	}
	callInfo := struct {
	}{}
	lockGlobalDNSProviderInterfaceMockObjectClient.Lock()
	mock.calls.ObjectClient = append(mock.calls.ObjectClient, callInfo)
	lockGlobalDNSProviderInterfaceMockObjectClient.Unlock()
	return mock.ObjectClientFunc()
}

// ObjectClientCalls gets all the calls that were made to ObjectClient.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.ObjectClientCalls())
func (mock *GlobalDNSProviderInterfaceMock) ObjectClientCalls() []struct {
} {
	var calls []struct {
	}
	lockGlobalDNSProviderInterfaceMockObjectClient.RLock()
	calls = mock.calls.ObjectClient
	lockGlobalDNSProviderInterfaceMockObjectClient.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *GlobalDNSProviderInterfaceMock) Update(in1 *v3.GlobalDNSProvider) (*v3.GlobalDNSProvider, error) {
	if mock.UpdateFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.UpdateFunc: method is nil but GlobalDNSProviderInterface.Update was just called")
	}
	callInfo := struct {
		In1 *v3.GlobalDNSProvider
	}{
		In1: in1,
	}
	lockGlobalDNSProviderInterfaceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockGlobalDNSProviderInterfaceMockUpdate.Unlock()
	return mock.UpdateFunc(in1)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.UpdateCalls())
func (mock *GlobalDNSProviderInterfaceMock) UpdateCalls() []struct {
	In1 *v3.GlobalDNSProvider
} {
	var calls []struct {
		In1 *v3.GlobalDNSProvider
	}
	lockGlobalDNSProviderInterfaceMockUpdate.RLock()
	calls = mock.calls.Update
	lockGlobalDNSProviderInterfaceMockUpdate.RUnlock()
	return calls
}

// Watch calls WatchFunc.
func (mock *GlobalDNSProviderInterfaceMock) Watch(opts v1.ListOptions) (watch.Interface, error) {
	if mock.WatchFunc == nil {
		panic("GlobalDNSProviderInterfaceMock.WatchFunc: method is nil but GlobalDNSProviderInterface.Watch was just called")
	}
	callInfo := struct {
		Opts v1.ListOptions
	}{
		Opts: opts,
	}
	lockGlobalDNSProviderInterfaceMockWatch.Lock()
	mock.calls.Watch = append(mock.calls.Watch, callInfo)
	lockGlobalDNSProviderInterfaceMockWatch.Unlock()
	return mock.WatchFunc(opts)
}

// WatchCalls gets all the calls that were made to Watch.
// Check the length with:
//     len(mockedGlobalDNSProviderInterface.WatchCalls())
func (mock *GlobalDNSProviderInterfaceMock) WatchCalls() []struct {
	Opts v1.ListOptions
} {
	var calls []struct {
		Opts v1.ListOptions
	}
	lockGlobalDNSProviderInterfaceMockWatch.RLock()
	calls = mock.calls.Watch
	lockGlobalDNSProviderInterfaceMockWatch.RUnlock()
	return calls
}

var (
	lockGlobalDNSProvidersGetterMockGlobalDNSProviders sync.RWMutex
)

// Ensure, that GlobalDNSProvidersGetterMock does implement GlobalDNSProvidersGetter.
// If this is not the case, regenerate this file with moq.
var _ v3.GlobalDNSProvidersGetter = &GlobalDNSProvidersGetterMock{}

// GlobalDNSProvidersGetterMock is a mock implementation of GlobalDNSProvidersGetter.
//
//     func TestSomethingThatUsesGlobalDNSProvidersGetter(t *testing.T) {
//
//         // make and configure a mocked GlobalDNSProvidersGetter
//         mockedGlobalDNSProvidersGetter := &GlobalDNSProvidersGetterMock{
//             GlobalDNSProvidersFunc: func(namespace string) v3.GlobalDNSProviderInterface {
// 	               panic("mock out the GlobalDNSProviders method")
//             },
//         }
//
//         // use mockedGlobalDNSProvidersGetter in code that requires GlobalDNSProvidersGetter
//         // and then make assertions.
//
//     }
type GlobalDNSProvidersGetterMock struct {
	// GlobalDNSProvidersFunc mocks the GlobalDNSProviders method.
	GlobalDNSProvidersFunc func(namespace string) v3.GlobalDNSProviderInterface

	// calls tracks calls to the methods.
	calls struct {
		// GlobalDNSProviders holds details about calls to the GlobalDNSProviders method.
		GlobalDNSProviders []struct {
			// Namespace is the namespace argument value.
			Namespace string
		}
	}
}

// GlobalDNSProviders calls GlobalDNSProvidersFunc.
func (mock *GlobalDNSProvidersGetterMock) GlobalDNSProviders(namespace string) v3.GlobalDNSProviderInterface {
	if mock.GlobalDNSProvidersFunc == nil {
		panic("GlobalDNSProvidersGetterMock.GlobalDNSProvidersFunc: method is nil but GlobalDNSProvidersGetter.GlobalDNSProviders was just called")
	}
	callInfo := struct {
		Namespace string
	}{
		Namespace: namespace,
	}
	lockGlobalDNSProvidersGetterMockGlobalDNSProviders.Lock()
	mock.calls.GlobalDNSProviders = append(mock.calls.GlobalDNSProviders, callInfo)
	lockGlobalDNSProvidersGetterMockGlobalDNSProviders.Unlock()
	return mock.GlobalDNSProvidersFunc(namespace)
}

// GlobalDNSProvidersCalls gets all the calls that were made to GlobalDNSProviders.
// Check the length with:
//     len(mockedGlobalDNSProvidersGetter.GlobalDNSProvidersCalls())
func (mock *GlobalDNSProvidersGetterMock) GlobalDNSProvidersCalls() []struct {
	Namespace string
} {
	var calls []struct {
		Namespace string
	}
	lockGlobalDNSProvidersGetterMockGlobalDNSProviders.RLock()
	calls = mock.calls.GlobalDNSProviders
	lockGlobalDNSProvidersGetterMockGlobalDNSProviders.RUnlock()
	return calls
}
